--
--
-- DMEMORY module (provides the data memory for the DLX computer)
--library Altera, IEEE;
--use Altera.MaxPlus2.all;
--Library Synopsys, IEEE;
--use Synopsys.attributes.all;
library IEEE;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_SIGNED.all;
--use work.mydff.all;

entity dmemory is

 
   port(rd_bus_D : out std_logic_vector(0 to 7);
        ra_bus : in std_logic_vector(0 to 7);
        wd_bus : in std_logic_vector(0 to 7);
        MemRead_DD, Memwrite_DD, MemtoReg_DD : in std_logic;
        clock,reset: in std_logic);

end dmemory;

--
-- DMEMORY architecture
--

architecture behavioral of dmemory is
	  
    signal mem0,mem1,mem2,mem3,mem4,mem5,mem6,mem7,mem8 : std_logic_vector(0 to 7);
--    signal mem9,mem10,mem11,mem12,mem13,mem14,mem15 : std_logic_vector(0 to 7);
   --,mem16,mem17,mem18,mem19 : std_logic_vector(0 to 7);
    --signal mem20,mem21,mem22,mem23,mem24,mem25,mem26,mem27,mem28,mem29 : std_logic_vector(0 to 7);
	--signal mem30,mem31 : std_logic_vector(0 to 7);
    signal mux : std_logic_vector(0 to 7);
    signal mem0wr,mem1wr,mem2wr,mem3wr,mem4wr,mem5wr,mem6wr,mem7wr,mem8wr : std_logic;
--    signal mem9wr,mem10wr,mem11wr,mem12wr,mem13wr,mem14wr,mem15wr: std_logic;
   --mem16wr,mem17wr,mem18wr,mem19wr : std_logic;
   -- signal mem20wr,mem21wr,mem22wr,mem23wr,mem24wr,mem25wr,mem26wr,mem27wr,mem28wr,mem29wr : std_logic;
   -- signal mem30wr,mem31wr : std_logic;
	signal rd_bus : std_logic_vector(0 to 7);


begin
-- Read Data Memory
with ra_bus(3 to 7) select
  mux(0 to 7) <= mem0(0 to 7)  WHEN "00000",
  	     mem1(0 to 7) WHEN "00001",
	     mem2(0 to 7) WHEN "00010",
	     mem3(0 to 7) WHEN "00011",
	     mem4(0 to 7) WHEN "00100",
	     mem5(0 to 7) WHEN "00101",
	     mem6(0 to 7) WHEN "00110",
         mem7(0 to 7) WHEN "00111",
         mem8(0 to 7) WHEN "01000",
	     --mem9(0 to 7) WHEN "01001",
	     --mem10(0 to 7) WHEN "01010",
	     --mem11(0 to 7) WHEN "01011",
	     --mem12(0 to 7) WHEN "01100",
	     --mem13(0 to 7) WHEN "01101",
	     --mem14(0 to 7) WHEN "01110",
         --mem15(0 to 7) WHEN "01111",
         --mem16 (0 to 7) WHEN "10000",
	     --mem17 (0 to 7) WHEN "10001",
	     --mem18 (0 to 7) WHEN "10010",
	     --mem19 (0 to 7) WHEN "10011",
	     --mem20 (0 to 7) WHEN "10100",
	     --mem21 (0 to 7) WHEN "10101",
	     --mem22 (0 to 7) WHEN "10110",
         --mem23 (0 to 7) WHEN "10111",
	     --mem24 (0 to 7) WHEN "11000",
	     --mem25 (0 to 7) WHEN "11001",
	     --mem26 (0 to 7) WHEN "11010",
	     --mem27 (0 to 7) WHEN "11011",
	     --mem28 (0 to 7) WHEN "11100",
	     --mem29 (0 to 7) WHEN "11101",
	     --mem30 (0 to 7) WHEN "11110",
         --mem31 (0 to 7) WHEN "11111",
         "11111111" WHEN others;

-- Mux to skip data memory for Rformat instructions
rd_bus(0 to 7) <= ra_bus(0 to 7) WHEN (MemtoReg_DD='0') ELSE mux WHEN (MemRead_DD='1')
             ELSE "00000000";

-- write to data memory?
-- The following code sets an initial value and replaces the next line
--dff_v(wd_bus,clock AND Memwrite_DD AND (ra_bus(0 to 2)="000"),mem0);

mem0wr  <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="00000")) ELSE '0';
mem1wr  <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="00001")) ELSE '0';
mem2wr  <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="00010")) ELSE '0';
mem3wr  <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="00011")) ELSE '0';
mem4wr  <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="00100")) ELSE '0';
mem5wr  <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="00101")) ELSE '0';
mem6wr  <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="00110")) ELSE '0';
mem7wr  <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="00111")) ELSE '0';
mem8wr  <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="01000")) ELSE '0';
--mem9wr  <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="01001")) ELSE '0';
--mem10wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="01010")) ELSE '0';
--mem11wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="01011")) ELSE '0';
--mem12wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="01100")) ELSE '0';
--mem13wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="01101")) ELSE '0';
--mem14wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="01110")) ELSE '0';
--mem15wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="01111")) ELSE '0';
--mem16wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="10000")) ELSE '0';
--mem17wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="10001")) ELSE '0';
--mem18wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="10010")) ELSE '0';
--mem19wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="10011")) ELSE '0';
--mem20wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="10100")) ELSE '0';
--mem21wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="10101")) ELSE '0';
--mem22wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="10110")) ELSE '0';
--mem23wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="10111")) ELSE '0';
--mem24wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="11000")) ELSE '0';
--mem25wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="11001")) ELSE '0';
--mem26wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="11010")) ELSE '0';
--mem27wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="11011")) ELSE '0';
--mem28wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="11100")) ELSE '0';
--mem29wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="11101")) ELSE '0';
--mem30wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="11110")) ELSE '0';
--mem31wr <= '1' When ((Memwrite_DD='1') AND (ra_bus(3 to 7)="11111")) ELSE '0';

process
begin   
wait until clock'event and clock='1';
   if (reset = '1') then
      --mem0 <= To_stdlogicvector(X"55");
      --mem1 <= To_Stdlogicvector(X"55");
	  --mem2 <= To_Stdlogicvector(B"10101010");
      rd_bus_D(0 to 7) <= "00000000";
   else

-- We may want to change these to use their own flip-flops for
-- performance reasons.  see cmpe3510 dmemory module

   if mem0wr= '1' then mem0(0 to 7) <= wd_bus(0 to 7); else mem0(0 to 7) <= mem0(0 to 7); end if;  
   if mem1wr= '1' then mem1(0 to 7) <= wd_bus(0 to 7); else mem1(0 to 7) <= mem1(0 to 7); end if;
   if mem2wr= '1' then mem2(0 to 7) <= wd_bus(0 to 7); else mem2(0 to 7) <= mem2(0 to 7); end if;   
   if mem3wr= '1' then mem3(0 to 7) <= wd_bus(0 to 7); else mem3(0 to 7) <= mem3(0 to 7); end if;   
   if mem4wr= '1' then mem4(0 to 7) <= wd_bus(0 to 7); else mem4(0 to 7) <= mem4(0 to 7); end if;   
   if mem5wr= '1' then mem5(0 to 7) <= wd_bus(0 to 7); else mem5(0 to 7) <= mem5(0 to 7); end if;   
   if mem6wr= '1' then mem6(0 to 7) <= wd_bus(0 to 7); else mem6(0 to 7) <= mem6(0 to 7); end if;
   if mem7wr= '1' then mem7(0 to 7) <= wd_bus(0 to 7); else mem7(0 to 7) <= mem7(0 to 7); end if;
   if mem8wr= '1' then mem8(0 to 7) <= wd_bus(0 to 7); else mem8(0 to 7) <= mem8(0 to 7); end if;  
   --if mem9wr= '1' then mem9(0 to 7) <= wd_bus(0 to 7); else mem9(0 to 7) <= mem9(0 to 7); end if;
   --if mem10wr= '1' then mem10(0 to 7) <= wd_bus(0 to 7); else mem10(0 to 7) <= mem10(0 to 7); end if;   
   --if mem11wr= '1' then mem11(0 to 7) <= wd_bus(0 to 7); else mem11(0 to 7) <= mem11(0 to 7); end if;   
   --if mem12wr= '1' then mem12(0 to 7) <= wd_bus(0 to 7); else mem12(0 to 7) <= mem12(0 to 7); end if;   
   --if mem13wr= '1' then mem13(0 to 7) <= wd_bus(0 to 7); else mem13(0 to 7) <= mem13(0 to 7); end if;   
   --if mem14wr= '1' then mem14(0 to 7) <= wd_bus(0 to 7); else mem14(0 to 7) <= mem14(0 to 7); end if;
   --if mem15wr= '1' then mem15(0 to 7) <= wd_bus(0 to 7); else mem15(0 to 7) <= mem15(0 to 7); end if;
   --if mem16wr= '1' then mem16 <= wd_bus; else mem16 <= mem16; end if;  
   --if mem17wr= '1' then mem17 <= wd_bus; else mem17 <= mem17; end if;
   --if mem18wr= '1' then mem18 <= wd_bus; else mem18 <= mem18; end if;   
   --if mem19wr= '1' then mem19 <= wd_bus; else mem19 <= mem19; end if;   
   --if mem20wr= '1' then mem20 <= wd_bus; else mem20 <= mem20; end if;   
   --if mem21wr= '1' then mem21 <= wd_bus; else mem21 <= mem21; end if;   
   --if mem22wr= '1' then mem22 <= wd_bus; else mem22 <= mem22; end if;
   --if mem23wr= '1' then mem23 <= wd_bus; else mem23 <= mem23; end if;
   --if mem24wr= '1' then mem24 <= wd_bus; else mem24 <= mem24; end if;  
   --if mem25wr= '1' then mem25 <= wd_bus; else mem25 <= mem25; end if;
   --if mem26wr= '1' then mem26 <= wd_bus; else mem26 <= mem26; end if;   
   --if mem27wr= '1' then mem27 <= wd_bus; else mem27 <= mem27; end if;   
   --if mem28wr= '1' then mem28 <= wd_bus; else mem28 <= mem28; end if;   
   --if mem29wr= '1' then mem29 <= wd_bus; else mem29 <= mem29; end if;   
   --if mem30wr= '1' then mem30 <= wd_bus; else mem30 <= mem30; end if;
   --if mem31wr= '1' then mem31 <= wd_bus; else mem31 <= mem31; end if;
   rd_bus_D(0 to 7) <= rd_bus(0 to 7); 

  end if;


end process;
end behavioral;

